extern "C" {
	#define __KEYBIOS_H__
	#include "fxlib.h"
	#include "MonochromeLib.h"
	#include "stdlib.h"
	#include "string.h"
}
#include <iostream>

#define KEY_CHAR_0 OS2(0x30,71)
#define KEY_CHAR_1 OS2(0x31,72)
#define KEY_CHAR_2 OS2(0x32,62)
#define KEY_CHAR_3 OS2(0x33,52)
#define KEY_CHAR_4 OS2(0x34,73)
#define KEY_CHAR_5 OS2(0x35,63)
#define KEY_CHAR_6 OS2(0x36,53)
#define KEY_CHAR_7 OS2(0x37,74)
#define KEY_CHAR_8 OS2(0x38,64)
#define KEY_CHAR_9 OS2(0x39,54)
#define KEY_CHAR_DP OS2(0x2e,61)
#define KEY_CHAR_EXP OS2(0x0f,51)
#define KEY_CHAR_PMINUS OS2(0x87,41)
#define KEY_CHAR_PLUS OS2(0x89,42)
#define KEY_CHAR_MINUS OS2(0x99,32)
#define KEY_CHAR_MULT OS2(0xa9,43)
#define KEY_CHAR_DIV OS2(0xb9,33)
#define KEY_CHAR_FRAC OS2(0xbb,75)
#define KEY_CHAR_LPAR OS2(0x28,55)
#define KEY_CHAR_RPAR OS2(0x29,45)
#define KEY_CHAR_COMMA OS2(0x2c,35)
#define KEY_CHAR_STORE OS2(0x0e,25)
#define KEY_CHAR_LOG OS2(0x95,66)
#define KEY_CHAR_LN OS2(0x85,56)
#define KEY_CHAR_SIN OS2(0x81,46)
#define KEY_CHAR_COS OS2(0x82,36)
#define KEY_CHAR_TAN OS2(0x83,26)
#define KEY_CHAR_SQUARE OS2(0x8b,67)
#define KEY_CHAR_POW OS2(0xa8,57)
#define KEY_CTRL_EXE OS2(30004,31)
#define KEY_CTRL_DEL OS2(30025,44)
#define KEY_CTRL_AC OS2(30015,32)
#define KEY_CTRL_FD OS2(30046,65)
#define KEY_CTRL_EXIT OS2(30002,47)
#define KEY_CTRL_SHIFT OS2(30006,78)
#define KEY_CTRL_ALPHA OS2(30007,77)
#define KEY_CTRL_OPTN OS2(30008,68)
#define KEY_CTRL_VARS OS2(30016,58)
#define KEY_CTRL_UP OS2(30018,28)
#define KEY_CTRL_DOWN OS2(30023,37)
#define KEY_CTRL_LEFT OS2(30020,38)
#define KEY_CTRL_RIGHT OS2(30021,27)
#define KEY_CTRL_F1 OS2(30009,79)
#define KEY_CTRL_F2 OS2(30010,69)
#define KEY_CTRL_F3 OS2(30011,59)
#define KEY_CTRL_F4 OS2(30012,49)
#define KEY_CTRL_F5 OS2(30013,39)
#define KEY_CTRL_F6 OS2(30014,29)
#define KEY_CTRL_MENU OS2(30003,48)
 
#ifndef isOS2// This is new
 
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
 
int OSVersionAsInt(void)
{
char mainversion;
char minorversion;
short release;
short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
 
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
 
#endif
 
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
 
unsigned short key[8] = {0};
 
int KeyDown(int keycode)
{
if(isOS2)
{
int row, col, word, bit;
row = keycode%10;
col = keycode/10-1;
word = row>>1;
bit = col + 8*(row&1);
memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
Sleep(1); //slow down, this function is faster than IsKeyDown() :-P
 
return (0 != (key[word] & 1<<bit));
}
else
{
return IsKeyDown(keycode);
}
}
 
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)


char vies;
char resist;
char xv;
char xe;
char ye;
char map[16][8];
int C;
int temps;


unsigned char* int2str(unsigned char* c, int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        if(n<0)
        {
            c[0] = '-';
            n=abs(n);
            l++;
        }
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
	return c;
}

void augtemps() {
	temps++;
}

int perdu() {
	ML_clear_vram();
	PopUpWin(5);
	PrintXY(34,24,"GAME OVER !",0);
	ML_display_vram();
	Sleep(500);
	while(IsKeyUp(KEY_CTRL_EXE));
	Sleep(150);
	return 1;
}

int gagne() {
	unsigned char tps[4];
	int2str(tps,temps+1);
	ML_clear_vram();
	PopUpWin(5);
	PrintXY(44,18,"GAGNE !",0);
	PrintXY(30,33,"TEMPS :",0);
	PrintXY(78,33,tps,0);
	ML_display_vram();
	Sleep(500);
	while(IsKeyUp(KEY_CTRL_EXE));
	Sleep(150);
	return 1;
}

void dessin() {
	unsigned char astro1[] = { 96,146,173,69,66,148,100,24 };
	unsigned char astro2[] = { 112,140,162,69,81,130,153,102 };
	unsigned char astro3[] = { 48,72,136,166,69,81,137,118 };
	unsigned char vaisseau[] = {
		8,16,20,40,36,36,36,36,72,18,72,18,137,145,138,81,
		132,33,135,225,132,33,135,225,132,33,67,194,48,12,15,240 };
	unsigned char ennemi[] = {
		1,128,2,64,4,32,4,32,8,16,8,16,17,136,18,72,
		34,68,37,164,68,34,69,162,130,65,153,153,100,38,3,192 };
	unsigned char ennemi_mask[] = {
		255,255,254,127,252,63,252,63,248,31,248,31,241,143,242,79,
		226,71,229,167,196,35,197,163,130,65,153,153,252,63,255,255 };
	unsigned char vaisseau_mask[] = {
		255,255,247,239,231,231,231,231,207,243,207,243,143,241,142,113,
		132,33,135,225,132,33,135,225,132,33,195,195,240,15,255,255 };

	ML_clear_vram();

	for(int j=0; j<8; j++) {
		for(int i=0; i<16; i++) {
			switch(map[i][j]) {
			case 1:
				ML_bmp_8_or(astro1,8*i,8*j);
				break;
			case 2:
				ML_bmp_8_or(astro2,8*i,8*j);
				break;
			case 3:
				ML_bmp_8_or(astro3,8*i,8*j);
				break;
			}
		}
	}

	ML_bmp_or(vaisseau,8*xv,47,16,16);
	ML_bmp_and(vaisseau_mask,8*xv,47,16,16);

	ML_bmp_or(ennemi,8*xe,8*ye,16,16);
	ML_bmp_and(ennemi_mask,8*xe,8*ye,16,16);

	ML_display_vram();
}

void tir(char s) {
	char xt;
	char yt;
	char impact;
	impact=0;
	if(s==1) xt=8*xv+5;
	else xt=8*xv+10;
	for(int i=5; i>2; i--) {
		if(map[xv+s-1][i]) {
			impact=i;
			break;
		}
	}
	if(impact==0 && (xv+s-1==xe || xv+s-2==xe)) {
		for(yt=47; yt>13; yt--) {
			ML_pixel(xt,yt,ML_BLACK);
			ML_display_vram();
		}
		for(int r=0; r<20; r++) {
			ML_filled_circle(xt,yt,r,ML_BLACK);
			ML_display_vram();
			Sleep(5);
		}
		resist--;
	} else if(impact==0) {
		for(yt=47; yt>=0; yt--) {
			ML_pixel(xt,yt,ML_BLACK);
			ML_display_vram();
		}
	} else {
		for(yt=47; yt>8*impact+3; yt--) {
			ML_pixel(xt,yt,ML_BLACK);
			ML_display_vram();
		}
		map[xv+s-1][impact]=0;
		for(int r=0; r<120; r++) {
			ML_filled_circle(xt,yt,r,ML_BLACK);
			ML_display_vram();
			Sleep(3);
		}
		vies--;
	}
}

int jeu(char v, char r) {
	char alea;
	for(int j=7; j>0; j--) {
		for(int i=0; i<16; i++) {
			map[i][j]=0;
		}
	}
	xv=1;
	xe=13;
	ye=8;
	vies=v;
	resist=r;
	C=0;
	temps=0;
	SetTimer(1,1000,augtemps);
	do {
		C++;
		for(int j=7; j>0; j--) {
			for(int i=0; i<16; i++) {
				map[i][j]=map[i][j-1];
			}
		}
		for(int i=0; i<16; i++) {
			map[i][0]=0;
		}
		do {
			alea=rand()%16;
		} while(map[alea][1] || map[alea-1][0] || map[alea+1][0]);
		map[alea][0]=rand()%3+1;
		if(ye>0 && C>7) ye--;
		if(C>15) xe+=rand()%3-1;
		if(xe>14)xe--;
		if(xe<0)xe++;
		dessin();
		Sleep(200);
		if(IsKeyDown(KEY_CTRL_F1) && xv>0) xv--;
		if(IsKeyDown(KEY_CTRL_F6) && xv<14) xv++;
		if(IsKeyDown(KEY_CTRL_F2)) tir(1);
		else if(IsKeyDown(KEY_CTRL_F5)) tir(2);
		if(map[xv][6] || map[xv+1][6] || map[xv][7] || map[xv+1][7]) {
			for(int r=0; r<120; r++) {
				ML_filled_circle(8*(xv+1),55,r,ML_BLACK);
				ML_display_vram();
				Sleep(3);
			}
			vies--;
			map[xv][6]=0;
			map[xv+1][6]=0;
			map[xv][7]=0;
			map[xv+1][7]=0;
		}
	} while(vies>0 && resist>0 && IsKeyUp(KEY_CTRL_EXIT));
	KillTimer(1);
	if(vies==0) return perdu();
	else if(resist==0) return gagne();
	else return 0;
}

int options() {
	char v,r;
	v=1;
	r=1;
	unsigned char chaine[4];
	Sleep(150);
	ML_clear_vram();
	PopUpWin(5);
	PrintXY(12,8,"Vos vies :",0);
	do {
		int2str(chaine,v);
		PrintXY(45,35,"-",0);
		PrintXY(80,35,"+",0);
		PrintXY(60,35,"  ",0);
		PrintXY(60,35,chaine,0);
		ML_display_vram();
		Sleep(100);
		if(IsKeyDown(KEY_CHAR_PLUS) && v<42) v++;
		if(IsKeyDown(KEY_CHAR_MINUS) && v>1) v--;
	} while(IsKeyUp(KEY_CTRL_EXE));
	Sleep(200);
	ML_clear_vram();
	PopUpWin(5);
	PrintXY(12,8,"Vies adversaire :",0);
	do {
		int2str(chaine,r);
		PrintXY(45,35,"-",0);
		PrintXY(80,35,"+",0);
		PrintXY(60,35,"  ",0);
		PrintXY(60,35,chaine,0);
		ML_display_vram();
		Sleep(100);
		if(IsKeyDown(KEY_CHAR_PLUS) && r<42) r++;
		if(IsKeyDown(KEY_CHAR_MINUS) && r>1) r--;
	} while(IsKeyUp(KEY_CTRL_EXE));
	return jeu(v,r);
}

int credits() {
	unsigned char ecran[] = {
		255,255,255,255,255,255,255,231,225,255,255,255,255,255,255,255,
		128,0,0,0,0,0,0,36,33,0,0,0,0,0,0,1,
		128,0,0,0,0,0,0,36,33,0,0,0,0,0,0,1,
		153,191,51,31,191,126,63,36,33,0,0,0,0,0,0,1,
		153,191,51,31,191,126,63,36,33,0,128,224,31,69,244,65,
		153,179,51,24,51,96,51,36,33,1,129,16,4,68,68,65,
		159,191,63,24,51,96,63,36,33,2,129,16,4,68,70,65,
		159,191,63,24,63,96,63,36,33,4,128,32,4,68,69,65,
		129,179,51,24,63,96,3,36,33,0,156,64,36,68,69,65,
		129,191,51,31,176,126,63,36,33,0,128,128,68,68,68,193,
		129,191,51,31,176,126,63,36,33,0,129,0,68,68,68,65,
		128,0,0,0,0,0,0,36,33,3,225,240,56,57,244,65,
		128,0,0,0,0,0,0,36,33,0,0,0,0,0,0,1,
		255,255,255,255,255,255,255,228,33,0,0,0,0,0,0,1,
		0,0,0,0,0,0,0,4,33,0,0,0,0,0,0,1,
		0,0,0,0,0,0,0,4,33,0,0,0,0,0,0,1,
		255,255,255,255,255,255,255,252,33,0,0,0,0,0,0,1,
		128,0,0,0,0,0,0,0,33,7,255,15,254,24,255,193,
		128,0,0,0,0,0,0,0,33,7,255,15,254,24,255,193,
		128,0,0,0,0,0,0,0,33,0,3,12,6,24,0,193,
		128,0,0,0,0,0,0,0,33,0,3,12,6,24,0,193,
		255,255,255,255,255,255,255,255,225,0,3,12,6,24,0,193,
		0,0,0,0,0,0,0,0,1,0,3,12,6,24,0,193,
		0,0,0,0,0,0,0,0,1,7,255,12,6,24,255,193,
		127,255,255,255,255,255,255,255,249,7,255,12,6,24,255,193,
		64,0,0,0,0,0,0,0,9,6,0,12,6,24,0,193,
		64,0,0,0,0,0,0,0,9,6,0,12,6,24,0,193,
		66,3,249,4,128,254,65,33,9,6,0,12,6,24,0,193,
		66,2,9,4,128,130,65,18,9,6,0,12,6,24,0,193,
		66,2,9,4,128,130,65,8,9,7,255,15,254,24,255,193,
		66,2,9,4,128,130,65,4,9,7,255,15,254,24,255,193,
		66,2,9,4,128,130,65,18,9,0,0,0,0,0,0,1,
		67,243,249,252,252,254,127,33,9,0,0,0,0,0,0,1,
		64,0,0,0,0,0,0,0,9,0,0,0,0,0,0,1,
		64,0,0,0,0,0,0,0,9,255,255,255,255,255,255,255,
		127,255,255,255,255,255,255,255,248,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,15,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,136,0,0,0,0,0,0,0,0,0,0,0,0,1,
		128,0,136,0,0,0,0,0,0,0,0,0,0,0,0,1,
		128,0,136,0,0,0,0,0,0,0,0,0,0,0,0,1,
		140,24,136,0,0,0,0,0,0,0,0,0,0,0,0,1,
		146,36,136,127,255,255,255,255,255,255,255,255,255,255,255,255,
		146,36,136,64,0,0,0,0,0,0,0,0,0,0,0,0,
		146,36,136,64,0,0,0,0,0,0,0,0,0,0,0,0,
		146,36,136,79,255,255,255,255,255,255,255,255,255,255,255,255,
		146,36,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		146,36,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		146,36,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		146,36,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		145,196,136,72,126,129,250,23,239,223,128,126,253,251,247,225,
		144,4,136,72,66,129,10,20,1,16,0,64,133,0,68,33,
		146,36,136,72,66,129,10,20,1,16,0,64,133,0,68,33,
		144,4,136,72,66,129,11,20,1,16,0,64,133,0,68,33,
		147,228,136,72,126,129,250,151,193,31,14,64,253,248,68,33,
		148,20,136,72,64,129,10,84,1,16,0,64,132,8,68,33,
		146,36,136,72,64,129,10,52,1,16,0,64,132,8,68,33,
		145,196,136,72,64,129,10,20,1,16,0,64,132,8,68,33,
		136,8,136,72,64,253,10,23,225,31,128,126,133,251,247,225,
		135,240,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		128,0,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		128,0,136,72,0,0,0,0,0,0,0,0,0,0,0,1,
		255,255,143,207,255,255,255,255,255,255,255,255,255,255,255,255 };
	ML_clear_vram();
	ML_bmp_or(ecran,0,0,128,64);
	ML_display_vram();
	Sleep(300);
	while(IsKeyUp(KEY_CTRL_EXE));
	for(int i=0; i<128; i++) {
		ML_vertical_line(i,0,64,ML_XOR);
		ML_display_vram();
		Sleep(15);
	}
	Sleep(200);
	return 1;
}

int menu() {
	unsigned char bandeau[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,125,19,129,244,78,56,227,159,121,3,128,228,78,124,0,
		0,17,20,64,70,209,69,20,68,69,4,65,20,81,16,0,
		0,17,20,0,69,81,69,4,4,69,4,1,4,81,16,0,
		0,17,247,0,68,81,68,227,132,121,7,0,231,209,16,0,
		0,17,20,0,68,94,68,16,68,69,4,0,20,81,16,0,
		0,17,20,64,68,80,69,20,68,69,20,65,20,81,16,0,
		0,17,19,129,244,80,56,227,159,120,227,128,228,78,16,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	unsigned char fleche[] = { 0,24,0,20,255,242,128,1,255,242,0,20,0,24 };
	char curs;
	curs=1;
	do {
		ML_clear_vram();
		ML_bmp_or(bandeau,0,0,128,15);
		PrintXY(42,21,"JOUER",0);
		PrintXY(42,34,"CREDITS",0);
		PrintXY(42,47,"SORTIR",0);
		ML_bmp_or(fleche,22,8+13*curs,16,7);
		ML_display_vram();
		Sleep(150);
		if(IsKeyDown(KEY_CTRL_UP) && curs>1) curs--;
		if(IsKeyDown(KEY_CTRL_DOWN) && curs<3) curs++;
	} while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT));
	if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
	else if(curs==1) return options();
	else if(curs==2) return credits();
	else return 0;
}

void louloux() {
	unsigned char ecran[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,127,128,0,0,0,0,63,0,0,0,0,0,0,0,0,
		0,64,128,0,0,0,0,33,0,0,0,0,0,0,0,0,
		0,64,128,0,0,0,0,33,0,0,0,0,0,0,0,0,
		0,64,128,0,0,0,0,33,0,0,0,0,0,0,0,0,
		0,64,128,0,0,0,0,33,0,0,0,0,0,0,0,0,
		0,64,128,63,224,0,126,33,0,127,192,248,0,0,0,0,
		0,64,128,32,32,0,66,33,0,64,64,136,0,0,0,0,
		0,64,128,32,32,0,66,33,0,64,64,136,0,126,252,0,
		0,64,128,32,32,0,66,33,0,64,64,136,0,66,132,0,
		0,64,128,32,32,62,66,33,0,64,64,136,248,66,132,0,
		0,64,128,39,252,34,66,33,0,79,248,136,136,79,228,0,
		0,64,128,36,36,34,66,33,0,72,72,136,136,74,164,0,
		0,64,128,36,36,34,66,33,0,72,72,136,136,74,164,0,
		0,64,128,36,36,34,66,33,0,72,72,136,136,126,252,0,
		0,64,128,36,36,34,66,33,0,72,72,136,136,8,32,0,
		0,127,255,36,36,34,66,33,0,72,72,136,136,254,252,0,
		0,64,129,36,36,63,250,33,0,72,72,191,248,138,164,0,
		0,64,129,36,36,34,74,63,254,72,72,168,136,143,228,0,
		0,64,129,63,228,34,74,33,2,127,200,168,136,130,132,0,
		0,64,129,4,4,34,74,33,2,8,8,168,136,130,132,0,
		0,64,129,4,4,34,74,33,2,8,8,168,136,130,132,0,
		0,64,129,4,4,34,74,33,2,8,8,168,136,130,252,0,
		0,127,255,7,252,63,254,63,254,15,248,255,248,254,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,128,0,248,3,192,1,192,1,240,7,0,7,1,255,255,
		255,191,126,251,251,221,181,222,253,247,247,87,119,125,3,255,
		255,191,126,251,251,221,181,222,253,247,247,87,119,125,123,255,
		255,191,126,251,251,221,181,222,253,247,247,87,119,125,123,255,
		255,191,126,192,27,221,181,222,253,128,55,87,119,125,123,255,
		255,191,126,219,219,221,181,192,1,183,183,87,119,112,27,255,
		255,191,126,219,219,192,5,222,255,183,183,64,7,117,91,255,
		255,128,0,219,219,221,189,222,255,183,183,119,119,1,3,255,
		255,191,127,219,219,221,189,222,255,183,183,119,119,247,223,255,
		255,191,127,219,219,221,189,222,255,183,183,119,119,129,3,255,
		255,191,127,219,219,221,189,222,255,183,183,119,119,181,91,255,
		255,191,127,219,219,221,189,222,255,183,183,119,119,181,91,255,
		255,191,127,216,3,221,189,222,255,176,7,119,119,176,27,255,
		255,191,127,223,223,193,189,222,255,191,191,119,7,189,123,255,
		255,191,127,223,223,255,189,222,255,191,191,119,255,189,123,255,
		255,191,127,223,223,255,189,222,255,191,191,119,255,129,3,255,
		255,191,127,223,223,255,189,222,255,191,191,119,255,255,255,255,
		255,191,127,192,31,255,129,222,255,128,63,7,255,255,255,255,
		255,191,127,255,255,255,255,222,255,255,255,255,255,255,255,255,
		255,191,127,255,255,255,255,222,255,255,255,255,255,255,255,255,
		255,191,127,255,255,255,255,222,255,255,255,255,255,255,255,255,
		255,191,127,255,255,255,255,222,255,255,255,255,255,255,255,255,
		255,128,127,255,255,255,255,192,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	ML_clear_vram();
	ML_bmp_or(ecran,0,0,128,64);
	ML_display_vram();
	Sleep(300);
	while(IsKeyUp(KEY_CTRL_EXE));
	for(int i=0; i<128; i++) {
		ML_vertical_line(i,0,64,ML_XOR);
		ML_display_vram();
		Sleep(15);
	}
	Sleep(200);
}

int main() {
	louloux();
	while(menu());
	return 1;
}

extern "C" {
	int AddIn_main(int isAppli, unsigned short OptionNum)
	{
		main();
		return 1;
	}

	#pragma section _BR_Size
	unsigned long BR_Size;
	#pragma section


	#pragma section _TOP


	int InitializeSystem(int isAppli, unsigned short OptionNum)
	{
		return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
	}

	#pragma section
}

